*** zfsimpl.c	Wed Nov 19 16:59:19 2008
--- zfsimpl.c.fix	Tue Dec  9 22:48:36 2008
***************
*** 721,731 ****
  	if (nvlist_find(nvlist,
  			ZPOOL_CONFIG_VDEV_TREE,
  			DATA_TYPE_NVLIST, 0, &vdevs)) {
  		return (EIO);
  	}
! 	vdev_init_from_nvlist(vdevs, &top_vdev);
  
  	/*
  	 * Add the toplevel vdev to the pool if its not already there.
  	 */
  	STAILQ_FOREACH(pool_vdev, &spa->spa_vdevs, v_childlink)
--- 721,733 ----
  	if (nvlist_find(nvlist,
  			ZPOOL_CONFIG_VDEV_TREE,
  			DATA_TYPE_NVLIST, 0, &vdevs)) {
  		return (EIO);
  	}
! 	int initRetVal = vdev_init_from_nvlist(vdevs, &top_vdev);
! 	if(initRetVal)
! 		return initRetVal;
  
  	/*
  	 * Add the toplevel vdev to the pool if its not already there.
  	 */
  	STAILQ_FOREACH(pool_vdev, &spa->spa_vdevs, v_childlink)
